
[![Discord](https://img.shields.io/discord/1026214085173461072)](https://discord.gg/Enf6Z3qhVr)
[![Supported Python Versions](https://img.shields.io/pypi/pyversions/textual/0.87.1)](https://pypi.org/project/textual/)
[![PyPI version](https://badge.fury.io/py/textual.svg)](https://badge.fury.io/py/textual)
![OS support](https://img.shields.io/badge/OS-macOS%20Linux%20Windows-red)



# Textual

Build sophisticated, cross-platform, user interfaces with a simple Python API.

Run your apps in the terminal or a web browser with [Textual Web](https://github.com/Textualize/textual-web) or [Textual Serve](https://github.com/Textualize/textual-serve).

## Videos

<details>
  <summary> 🎬 Demonstration </summary>
  <hr>

https://github.com/user-attachments/assets/71afec49-fe89-4e8d-a8cf-148fa2601362


 </details>



<details>
  <summary> 🎬 Textual Serve </summary>
  <hr>


https://github.com/user-attachments/assets/97ab8825-0af6-42e9-b7e5-f554303a2112




 </details>


## Textual in Action

<table>

<tr>

  <td>
    
  ![buttons](https://github.com/user-attachments/assets/2ac26387-aaa3-41ed-bc00-7d488600343c)
    
  </td>

  <td>
    
![tree](https://github.com/user-attachments/assets/61ccd6e9-97ea-4918-8eda-3ee0f0d3770e)
    
  </td>
  
</tr>

<tr>

  <td>
    
  ![datatables](https://github.com/user-attachments/assets/3e1f9f7a-f965-4901-a114-3c188bd17695)
    
  </td>

  <td>
    
![inputs](https://github.com/user-attachments/assets/b02aa203-7c37-42da-a1bb-2cb244b7d0d3)
    
  </td>
  
</tr>

</table>

### Impatient?

Try the [textual demo](https://github.com/textualize/textual-demo) *without* installing.

```bash
uvx --python 3.12 textual-demo
```

![Textual supports themes](https://github.com/user-attachments/assets/3de1a991-1154-48b4-b547-21f98509f8c4)



## Installing

Install Textual via pip:

```
pip install textual textual-dev
```

Check out the demo:

```
python -m textual
```

See [getting started](https://textual.textualize.io/getting_started/) for details.



## Documentation

Head over to the [Textual documentation](http://textual.textualize.io/) to start building!

## Join us on Discord

Join the Textual developers and community on our [Discord Server](https://discord.gg/Enf6Z3qhVr).
